import pygame
from UIelements import dial
from UIelements import light

neutroncount = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

def autocontrol(neutrons,importedSTLs, neutronsetpoint,rodsetpoint):
    neutroncount.pop(0)
    neutroncount.append(len(neutrons))
    rateofchange = neutroncount[len(neutroncount)-1]-neutroncount[len(neutroncount)-51]
    setrateofchange = (neutronsetpoint - len(neutrons))
    if  len(neutrons) > neutronsetpoint+500:
        if rateofchange < -30 and rodsetpoint < 300:
            rodsetpoint += .1
        elif rateofchange > -30 and rodsetpoint > 0:
            rodsetpoint -= .1
    if  len(neutrons) < neutronsetpoint-500:
        if rateofchange < 30 and rodsetpoint < 800:
            rodsetpoint += .1
        elif rateofchange > 30 and rodsetpoint > 0:
            rodsetpoint -= .1
    
    if  len(neutrons) > neutronsetpoint:
        if rateofchange < -10 and rodsetpoint < 300:
            rodsetpoint += .1
        elif rateofchange > -10 and rodsetpoint > 0:
            rodsetpoint -= .1
    if  len(neutrons) < neutronsetpoint:
        if rateofchange < 10 and rodsetpoint < 800:
            rodsetpoint += .1
        elif rateofchange > 10 and rodsetpoint > 0:
            rodsetpoint -= .1
    return rodsetpoint
    
    
    
def manualcontrol(neutrons,importedSTLs,rodsetpoint):

    return rodsetpoint

def controls(autocontrol, rodsetpoint, neutronsetpoint, neutrons,importedSTLs, mdisplay):
    dial(100,100,50,len(neutrons),True,mdisplay, "Neutron Count",(0,255,0))
    dial(250,100,50,rodsetpoint/8*3,True,mdisplay, "Rod Position",(0,255,0))
    NDs = []
    CRs = []
    for i in importedSTLs:
        if i[0][1] == "Neutron Detector":
            NDs.append(i[0][0])
        if i[0][1] == "Control Rod":
            CRs.append(i[0][0])
    #print(NDs)
    for i in range(0,len(CRs)):
        dial(importedSTLs[CRs[i]][1][0]*3+400,-importedSTLs[CRs[i]][1][1]*3+400,20,importedSTLs[CRs[i]][1][2]/800*360,True,mdisplay, f"CR{importedSTLs[CRs[i]][1][1],importedSTLs[CRs[i]][1][0]}",(255,0,0))
    for i in range(0,len(NDs)):
        #print(importedSTLs[NDs[i]][4][0][0])
        dial(importedSTLs[NDs[i]][1][0]*3+400,-importedSTLs[NDs[i]][1][1]*3+400,20,sum(importedSTLs[NDs[i]][4][0])/10,True,mdisplay, f"ND{importedSTLs[CRs[i]][1][1],importedSTLs[CRs[i]][1][0]}",(0,0,255))

    
    light(400,100,(255,0,0), 10, len(neutrons) - 300 > neutronsetpoint, mdisplay, "High Activity")
    light(400,120,(0,0,255), 10, len(neutrons) + 300 < neutronsetpoint, mdisplay, "Low Activity")
    light(400,140,(0,255,0), 10, autocontrol == 1, mdisplay, "Autocontrol")
